//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CSPIN.h"
#include <AppEvnts.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
typedef enum {
  closed,
  opened,
  unknown,
  blocked,
  emergency,
  waiting,
  moving 
} lift_status;

typedef struct {
  int pos;
  lift_status status;
  int ex;
  int *targets;
  int targetcount;
} lift_t;

typedef struct {
  bool up;
  int level;
} task_t;

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TEdit *AddrEdit;
        TLabel *Label1;
        TLabel *Label2;
        TCSpinEdit *PortSpin;
        TButton *Button1;
        TButton *Button2;
        TLabel *Prip;
        TApplicationEvents *ApplicationEvents1;
        TListBox *SL;
        TLabel *Label3;
        TListBox *RL;
        TLabel *Label4;
        TTimer *Timer1;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ApplicationEvents1Message(tagMSG &Msg,
          bool &Handled);
        void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
        int shaft_count, level_count;
        lift_t *shafts;
        int taskcount;
        task_t *tasks; 
        void _fastcall sendstr(char *str);
        void _fastcall command(char *str);
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
