//---------------------------------------------------------------------------

#include <winsock.h>
#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

#define WM_SOCKET WM_USER + 1
TForm1 *Form1;

SOCKET s;

void _fastcall TForm1::sendstr(char *str)
{
  int l = strlen(str);
  char *x = (char*)malloc(l + 3);
  strcpy(x, str);
  x[l] = 13;
  x[l + 1] = 10;
  x[l + 2] = 13;
  send(s, x, l + 2, 0);
  free(x);
  SL->Items->Add(str);
  if (SL->Items->Count > 10) SL->Items->Delete(0);
  tasks = NULL;
  taskcount = 0;
}

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  WSADATA ws;
  WSAStartup(0x0101, &ws);
  s = socket(PF_INET, SOCK_STREAM, 0);
  shafts = NULL;
}


void __fastcall TForm1::Button1Click(TObject *Sender)
{
  struct sockaddr_in address_;
  hostent* he = gethostbyname(AddrEdit->Text.c_str());

  if(!he) {
    ShowMessage("Divna adresa, zkuste to znovu");
    return;
  }

  address_.sin_family = AF_INET;
  address_.sin_port = htons(PortSpin->Value);
  address_.sin_addr = *((in_addr*)he->h_addr);
  memset(&(address_.sin_zero), '\0', 8);
  //zatim jen ziskavani adresy

  if (connect(s, (sockaddr *)&address_, sizeof (sockaddr))) {
    ShowMessage("Spojeni se nezdarilo");
    return;
  }
  //pripojit
  WSAAsyncSelect(s, Handle, WM_SOCKET, FD_READ | FD_CLOSE);//az nekdo bude neco chtit, rekni mi 
  Prip->Visible = true;
  sendstr("levels");
  sendstr("shafts");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  closesocket(s);
  Prip->Visible = false;        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  closesocket(s);
  WSACleanup();
  free(shafts);
  free(tasks);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ApplicationEvents1Message(tagMSG &Msg,
      bool &Handled)
{
  switch (Msg.message) {
    case WM_SOCKET: {
      if (Msg.lParam == 32) {
        Prip->Visible = false;
      } else {
        char str[1024];
        int length = recv(s, str, 1024, 0);
        char line[1024];
        if (length < 0) {
          ShowMessage("Minuly klient neukoncil komunikaci, prosim o restart serveru");
          return;
        }
        int linepos = 0;
        for (int i = 0; i < length; i++) {
          switch (str[i]) {
            case '\r': {//zpracovat
              line[linepos] = 0;
              command(line);
              linepos = 0;
              break;
            }
            case '\n': break;//nic
            default: {
              line[linepos] = str[i];
              linepos++;
            }
          }
        }
      }
      break;
    }
  }
}

void _fastcall TForm1::command(char *str)
{
  RL->Items->Add(str);
  while (RL->Items->Count > 10) RL->Items->Delete(0);
  int startpos = 0;
  char **strings = NULL;
  int stringcount = 0;
  for (int i = 0; i < strlen(str); i++) {//rozsekat na kusy
    switch (str[i]) {
      case ' ': {
        stringcount++;
        strings = (char **) realloc(strings, stringcount * sizeof * strings);
        int l = i - startpos;
        char *s = (char *) malloc(l + 1);
        memcpy(s, &str[startpos], l);
        s[l] = 0;
        startpos = i + 1;
        strings[stringcount - 1] = s;
      }
    }
  }
  if (startpos < strlen(str)){
    stringcount++;
    strings = (char **) realloc(strings, stringcount * sizeof * strings);
    int l = strlen(str) - startpos;
    char *s = (char *) malloc(l + 1);
    memcpy(s, &str[startpos], l);
    s[l] = 0;
    strings[stringcount - 1] = s;
  }

#define COM strings[0]
#define PAR1 strings[1]
#define PAR2 strings[2]

  if ((stringcount < 2) || (PAR1[0] != '"')) {

    if (stringcount == 0) return;
    strings[0] = UpperCase(strings[0]).c_str();
    if (strcmp(COM, "SHAFTS") == 0) {
      shaft_count = StrToInt(PAR1);
      shafts = (lift_t *) realloc(shafts, shaft_count * sizeof * shafts);
      for (int i = 0; i < shaft_count; i++) {
        char comm[50];
        sprintf(comm, "close %i", i);
        sendstr(comm);
        shafts[i].pos = 0;
        shafts[i].targetcount = 0;
        shafts[i].targets = NULL;
      }
    }
    if (strcmp(COM, "LEVELS") == 0) {
      level_count = StrToInt(PAR1);
    }
    if (strcmp(COM, "RESET") == 0) {
      sendstr("LEVELS");
      sendstr("SHAFTS");
    }
    if (strcmp(COM, "LEVELBUTTONUP") == 0) {
      char comm[100];
      sprintf(comm, "indiupon %s", PAR1);
      sendstr(comm);
      taskcount++;
      tasks = (task_t *) realloc(tasks, taskcount * sizeof *tasks);
#define ACTUAL tasks[taskcount - 1]
      ACTUAL.up = true;
      ACTUAL.level = StrToInt(PAR1);
#undef ACTUAL
      }
      if (strcmp(COM, "LEVELBUTTONDN") == 0) {
      char comm[100];
      sprintf(comm, "indiupdn %s", PAR1);
      sendstr(comm);
      taskcount++;
      tasks = (task_t *) realloc(tasks, taskcount * sizeof *tasks);
#define ACTUAL tasks[taskcount - 1]
      ACTUAL.up = false;
      ACTUAL.level = StrToInt(PAR1);
#undef ACTUAL
    }
    if (strcmp(COM, "LEVEL") == 0) {
      shafts[StrToInt(PAR1)].status = waiting;
      shafts[StrToInt(PAR1)].pos = StrToInt(PAR2);
      shafts[StrToInt(PAR1)].ex = 3;
      char comm[100];
    }
    if (strcmp(COM, "OPENED") == 0) {
      shafts[StrToInt(PAR1)].status = opened;
      shafts[StrToInt(PAR1)].ex = 50;
      char comm[100];
      sprintf(comm, "indiupoff %i", shafts[StrToInt(PAR1)].pos);
      sendstr(comm);
      sprintf(comm, "indidnoff %i", shafts[StrToInt(PAR1)].pos);
      sendstr(comm);
      sprintf(comm, "indioff %s %i", PAR1, shafts[StrToInt(PAR1)].pos);
      sendstr(comm);
    }
    if (strcmp(COM, "CLOSED") == 0) {
      lift_t *shaft = &shafts[StrToInt(PAR1)];
      shaft->status = closed;
      if (shaft->targetcount > 0) {
        char comm[100];
        sprintf(comm, "floor %s %i", PAR1, shaft->targets[0]);
        sendstr(comm);
        for (int i = 1; i < shaft->targetcount; i++) shaft->targets[i - 1] = shaft->targets[i];
        shaft->targets = (int *) realloc(shaft->targets, shaft->targetcount * sizeof * shaft->targets);
        shaft->status = moving;
      }
    }
    if (strcmp(COM, "CABINBUTTON") == 0) {
      lift_t *shaft = &shafts[StrToInt(PAR1)];
      shaft->targetcount++;
      shaft->targets = (int *) realloc(shaft->targets, shaft->targetcount * sizeof *shaft->targets);
      shaft->targets[shaft->targetcount - 1] = StrToInt(PAR2);
      char comm[100];
      sprintf(comm, "indion %s %s", PAR1, PAR2);
      sendstr(comm);
    }
    if (strcmp(COM, "BLOCK") == 0) {
      shafts[StrToInt(PAR1)].status = blocked;
    }
    if (strcmp(COM, "UNBLOCK") == 0) {
      char comm[100];
      sprintf(comm, "close %s", PAR1);
      sendstr(comm);
    }
  }
  try {
    for (int i = 0; i < stringcount; i++) free(strings[i]);
    free(strings);
  } catch(...) {
  }
}

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  if (taskcount > 0) {
    int level = tasks[0].level;
    int nearest = -1;
    for (int i = 0; i < shaft_count; i++) {
      if (shafts[i].status == closed) nearest = i;
    }
    if (nearest != -1) {
      int i = nearest;
      shafts[i].status = moving;
      shafts[i].targetcount++;
      shafts[i].targets = (int *) realloc(shafts[i].targets, shafts[i].targetcount * sizeof * shafts[i].targets);
      shafts[i].targets[shafts[i].targetcount] = level;
      char comm[100];
      if (level == shafts[i].pos) {
        sprintf(comm, "open %i", i);
        sendstr(comm);
      } else {
        sprintf(comm, "floor %i %i", i, level);
        sendstr(comm);
      }
      for (int j = 1; j < taskcount; j++) tasks[j - 1] = tasks[j];
      taskcount--;
      tasks = (task_t *) realloc(tasks, taskcount * sizeof * tasks);
    }
  }
  for (int i = 0; i < shaft_count; i++) {
    switch (shafts[i].status) {
      case opened: {
        shafts[i].ex--;
        if (shafts[i].ex == 0) {
          char comm[100];
          sprintf(comm, "close %i", i);
          sendstr(comm);
        }
        break;
      }
      case waiting: {
        shafts[i].ex--;
        if (shafts[i].ex == 0) {
          char comm[100];
          sprintf(comm, "open %i", i);
          sendstr(comm);
        }
        break;
      }
    }
  }
}
//---------------------------------------------------------------------------
